﻿using System;

namespace DOSBoxIPXServer
{
    class Program
    {
        class User
        {
            public System.Byte[] address = new System.Byte[6];
            public System.UInt32 time = 0;
        }

        static System.Net.EndPoint externalendpoint = new System.Net.IPEndPoint(System.Net.IPAddress.Any, 0);
        static System.Net.Sockets.Socket serversocket = new System.Net.Sockets.Socket(System.Net.Sockets.AddressFamily.InterNetwork, System.Net.Sockets.SocketType.Dgram, System.Net.Sockets.ProtocolType.Udp);
        static System.Collections.Generic.List<User> users = new System.Collections.Generic.List<User>();

        static void Main(System.String[] args)
        {
            try
            {
                System.Console.WriteLine("Hello World!");
                System.UInt16 port = 213;
                System.UInt32 timeout = 180;
                System.Int32 ping = 60000;
                if (args.Length == 0)
                {
                    System.Console.WriteLine("No args provided, assuming default settings.");
                }
                else if (args.Length == 1)
                {
                    port = System.UInt16.Parse(args[0]);
                    System.Console.WriteLine("Port provided, assuming default timeout and ping check.");
                }
                else if(args.Length == 2)
                {
                    port = System.UInt16.Parse(args[0]);
                    timeout = System.UInt32.Parse(args[1]);
                    System.Console.WriteLine("Port and timeout provided, assuming default ping check.");
                }
                else if (args.Length == 3)
                {
                    port = System.UInt16.Parse(args[0]);
                    timeout = System.UInt32.Parse(args[1]);
                    ping = System.Int32.Parse(args[2]);
                    System.Console.WriteLine("Proper args provided.");
                }
                else
                {
                    port = System.UInt16.Parse(args[0]);
                    timeout = System.UInt32.Parse(args[1]);
                    ping = System.Int32.Parse(args[2]);
                    System.Console.WriteLine("Too many args provided, parsing usuable args only.");
                }
                externalendpoint = new System.Net.IPEndPoint(System.Net.IPAddress.Parse(new System.Net.WebClient().DownloadString("https://krock.online/ip.php").Trim()), port);
                System.Net.EndPoint serverendpoint = new System.Net.IPEndPoint(System.Net.IPAddress.Any, port);
                serversocket.Bind(serverendpoint);
                System.Boolean looprun = true;
                System.Int32 receivefrombytes = 0;
                System.Byte[] buffer = new System.Byte[System.UInt16.MaxValue];
                System.Net.EndPoint receivefromendpoint = new System.Net.IPEndPoint(0, 0);
                System.UInt16 ipxpacketchecksum = 0;
                System.UInt16 ipxpacketlength = 0;
                System.Byte ipxpackettransportcontrol = 0;
                System.Byte ipxpacketpackettype = 0;
                System.UInt32 ipxpacketdestinationnetwork = 0;
                System.Byte[] ipxpacketdestinationnode = new System.Byte[6];
                System.UInt16 ipxpacketdestinationsocket = 0;
                System.UInt32 ipxpacketsourcenetwork = 0;
                System.Byte[] ipxpacketsourcenode = new System.Byte[6];
                System.UInt16 ipxpacketsourcesocket = 0;
                System.Threading.Thread userscheckthread = new System.Threading.Thread(new System.Threading.ThreadStart(UsersCheckThread));
                System.Threading.Thread pingthread = new System.Threading.Thread(new System.Threading.ParameterizedThreadStart(PingThread));
                userscheckthread.Start();
                pingthread.Start(ping);
                System.Console.WriteLine("Server starting.");
                while (looprun)
                {
                    receivefrombytes = serversocket.ReceiveFrom(buffer, ref receivefromendpoint);
                    if (receivefrombytes >= 30)
                    {
                        ipxpacketchecksum = (System.UInt16)((buffer[0] << 8) + buffer[1]);
                        ipxpacketlength = (System.UInt16)((buffer[2] << 8) + buffer[3]);
                        ipxpackettransportcontrol = buffer[4];
                        ipxpacketpackettype = buffer[5];
                        ipxpacketdestinationnetwork = (System.UInt32)((buffer[6] << 24) + (buffer[7] << 16) + (buffer[8] << 8) + buffer[9]);
                        ipxpacketdestinationnode[0] = buffer[10];
                        ipxpacketdestinationnode[1] = buffer[11];
                        ipxpacketdestinationnode[2] = buffer[12];
                        ipxpacketdestinationnode[3] = buffer[13];
                        ipxpacketdestinationnode[4] = buffer[14];
                        ipxpacketdestinationnode[5] = buffer[15];
                        ipxpacketdestinationsocket = (System.UInt16)((buffer[16] << 8) + buffer[17]);
                        ipxpacketsourcenetwork = (System.UInt32)((buffer[18] << 24) + (buffer[19] << 16) + (buffer[20] << 8) + buffer[21]);
                        ipxpacketsourcenode[0] = buffer[22];
                        ipxpacketsourcenode[1] = buffer[23];
                        ipxpacketsourcenode[2] = buffer[24];
                        ipxpacketsourcenode[3] = buffer[25];
                        ipxpacketsourcenode[4] = buffer[26];
                        ipxpacketsourcenode[5] = buffer[27];
                        ipxpacketsourcesocket = (System.UInt16)((buffer[28] << 8) + buffer[29]);
                        if (ipxpacketdestinationnetwork == 0 && ipxpacketdestinationnode[0] == 0 && ipxpacketdestinationnode[1] == 0 && ipxpacketdestinationnode[2] == 0 && ipxpacketdestinationnode[3] == 0 && ipxpacketdestinationnode[4] == 0 && ipxpacketdestinationnode[5] == 0 && ipxpacketdestinationsocket == 2 && ipxpacketsourcesocket == 2)
                        {
                            User newuser = new User();
                            newuser.address[0] = ((System.Net.IPEndPoint)receivefromendpoint).Address.GetAddressBytes()[0];
                            newuser.address[1] = ((System.Net.IPEndPoint)receivefromendpoint).Address.GetAddressBytes()[1];
                            newuser.address[2] = ((System.Net.IPEndPoint)receivefromendpoint).Address.GetAddressBytes()[2];
                            newuser.address[3] = ((System.Net.IPEndPoint)receivefromendpoint).Address.GetAddressBytes()[3];
                            newuser.address[4] = (System.Byte)(((System.Net.IPEndPoint)receivefromendpoint).Port >> 8);
                            newuser.address[5] = (System.Byte)(((System.Net.IPEndPoint)receivefromendpoint).Port);
                            newuser.time = timeout;
                            lock (users)
                            {
                                users.Add(newuser);
                            }
                            buffer[0] = 255;
                            buffer[1] = 255;
                            buffer[2] = 0;
                            buffer[3] = 30;
                            buffer[4] = 0;
                            buffer[5] = 0;
                            buffer[6] = 0;
                            buffer[7] = 0;
                            buffer[8] = 0;
                            buffer[9] = 0;
                            buffer[10] = newuser.address[0];
                            buffer[11] = newuser.address[1];
                            buffer[12] = newuser.address[2];
                            buffer[13] = newuser.address[3];
                            buffer[14] = newuser.address[4];
                            buffer[15] = newuser.address[5];
                            buffer[16] = 0;
                            buffer[17] = 2;
                            buffer[18] = 0;
                            buffer[19] = 0;
                            buffer[20] = 0;
                            buffer[21] = 1;
                            buffer[22] = 0;
                            buffer[23] = 0;
                            buffer[24] = 0;
                            buffer[25] = 0;
                            buffer[26] = 0;
                            buffer[27] = 0;
                            buffer[28] = 0;
                            buffer[29] = 2;
                            System.Int32 sendtobytes = serversocket.SendTo(buffer, 30, System.Net.Sockets.SocketFlags.None, receivefromendpoint);
                        }
                        else if (ipxpacketdestinationnetwork == 0 && ipxpacketdestinationsocket == 2 && ipxpacketsourcenetwork == 0 && ipxpacketsourcesocket == 2)
                        {
                            lock (users)
                            {
                                for (System.Int32 a = 0; a < users.Count; a++)
                                {
                                    if (users[a].address[0] == ipxpacketsourcenode[0] && users[a].address[1] == ipxpacketsourcenode[1] && users[a].address[2] == ipxpacketsourcenode[2] && users[a].address[3] == ipxpacketsourcenode[3] && users[a].address[4] == ipxpacketsourcenode[4] && users[a].address[5] == ipxpacketsourcenode[5])
                                    {
                                        users[a].time = timeout;
                                        break;
                                    }
                                }
                            }
                        }
                        else if (ipxpacketdestinationnode[0] == 255 && ipxpacketdestinationnode[1] == 255 && ipxpacketdestinationnode[2] == 255 && ipxpacketdestinationnode[3] == 255 && ipxpacketdestinationnode[4] == 255 && ipxpacketdestinationnode[5] == 255)
                        {
                            lock (users)
                            {
                                for (System.Int32 a = 0; a < users.Count; a++)
                                {
                                    if (users[a].address[0] == ipxpacketsourcenode[0] && users[a].address[1] == ipxpacketsourcenode[1] && users[a].address[2] == ipxpacketsourcenode[2] && users[a].address[3] == ipxpacketsourcenode[3] && users[a].address[4] == ipxpacketsourcenode[4] && users[a].address[5] == ipxpacketsourcenode[5])
                                    {
                                    }
                                    else
                                    {
                                        System.Int32 sendtobytes = serversocket.SendTo(buffer, receivefrombytes, System.Net.Sockets.SocketFlags.None, new System.Net.IPEndPoint(new System.Net.IPAddress(new System.Byte[] { users[a].address[0], users[a].address[1], users[a].address[2], users[a].address[3] }), (System.UInt16)((users[a].address[4] << 8) + users[a].address[5])));
                                        if (serversocket.Available == 1)
                                        {
                                            users.RemoveAt(a);
                                        }
                                    }
                                }
                            }
                        }
                        else
                        {
                            if (ipxpacketdestinationnode[0] == 0 && ipxpacketdestinationnode[1] == 0 && ipxpacketdestinationnode[2] == 0 && ipxpacketdestinationnode[3] == 0 && ipxpacketdestinationnode[4] == 0 && ipxpacketdestinationnode[5] == 0)
                            {
                                // Apparently this is for router discovery or something like that. Gotta keep an eye on this.
                            }
                            else
                            {                            
                                System.Int32 sendtobytes = serversocket.SendTo(buffer, receivefrombytes, System.Net.Sockets.SocketFlags.None, new System.Net.IPEndPoint(new System.Net.IPAddress(new System.Byte[] { ipxpacketdestinationnode[0], ipxpacketdestinationnode[1], ipxpacketdestinationnode[2], ipxpacketdestinationnode[3] }), (System.UInt16)((ipxpacketdestinationnode[4] << 8) + ipxpacketdestinationnode[5])));
                            }
                        }             
                    }
                    else
                    {
                    }
                }
            }
            catch(System.Exception e)
            {
                System.Console.WriteLine(e);
            }
        }

        static void UsersCheckThread()
        {
            try
            {
                System.Boolean looprun = true;
                while (looprun)
                {
                    System.Threading.Thread.Sleep(1000);
                    lock (users)
                    {
                        for (System.Int32 a = 0; a < users.Count; a++)
                        {
                            users[a].time--;
                            if (users[a].time == 0)
                            {
                                users.RemoveAt(a);
                            }
                        }
                    }
                }
            }
            catch(System.Exception e)
            {
                System.Console.WriteLine(e);
            }
        }

        static void PingThread(System.Object o)
        {
            try
            {
                System.Boolean looprun = true;
                System.Int32 ping = (System.Int32)o;
                System.Byte[] packet = new System.Byte[30];
                packet[0] = 255;
                packet[1] = 255;
                packet[2] = 0;
                packet[3] = 30;
                packet[4] = 0;
                packet[5] = 0;
                packet[6] = 0;
                packet[7] = 0;
                packet[8] = 0;
                packet[9] = 0;
                packet[10] = 255;
                packet[11] = 255;
                packet[12] = 255;
                packet[13] = 255;
                packet[14] = 255;
                packet[15] = 255;
                packet[16] = 0;
                packet[17] = 2;
                packet[18] = 0;
                packet[19] = 0;
                packet[20] = 0;
                packet[21] = 0;
                packet[22] = ((System.Net.IPEndPoint)externalendpoint).Address.GetAddressBytes()[0];
                packet[23] = ((System.Net.IPEndPoint)externalendpoint).Address.GetAddressBytes()[1];
                packet[24] = ((System.Net.IPEndPoint)externalendpoint).Address.GetAddressBytes()[2];
                packet[25] = ((System.Net.IPEndPoint)externalendpoint).Address.GetAddressBytes()[3];
                packet[26] = (System.Byte)(((System.Net.IPEndPoint)externalendpoint).Port >> 8);
                packet[27] = (System.Byte)(((System.Net.IPEndPoint)externalendpoint).Port);
                packet[28] = 0;
                packet[29] = 2;
                while (looprun)
                {
                    System.Threading.Thread.Sleep(ping);
                    lock (users)
                    {
                        for (System.Int32 a = 0; a < users.Count; a++)
                        {
                            System.Int32 sendtobytes = serversocket.SendTo(packet, new System.Net.IPEndPoint(new System.Net.IPAddress(new System.Byte[] { users[a].address[0], users[a].address[1], users[a].address[2], users[a].address[3] }), (System.UInt16)((users[a].address[4] << 8) + users[a].address[5])));
                        }
                    }
                }
            }
            catch(System.Exception e)
            {
                System.Console.WriteLine(e);
            }
        }
    }
}
